diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-mode.h ns-3.36/src/wifi/model/wifi-mode.h
--- ns-3.35/src/wifi/model/wifi-mode.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-mode.h	2022-04-30 18:23:58.214735300 -0700
@@ -55,6 +55,12 @@
    */
   bool IsAllowed (uint16_t channelWidth, uint8_t nss) const;
   /**
+   * \returns true if this TXVECTOR combination is allowed, false otherwise.
+   *
+   * \param txVector the const WifiTxVector& of the signal
+   */
+  bool IsAllowed (const WifiTxVector& txVector) const;
+  /**
    *
    * \param channelWidth the considered channel width in MHz
    * \param guardInterval the considered guard interval duration in nanoseconds
@@ -279,42 +285,22 @@
   typedef Callback<uint16_t> ConstellationSizeCallback;
   /**
    * Typedef for callback used to calculate PHY rate of a WifiMode
-   *
-   * \param channelWidth the channel width in MHz
-   * \param guardInterval the guard interval duration in nanoseconds
-   * \param nss the number of streams
-   * \return the physical bit rate of the signal in bps.
-   */
-  typedef Callback<uint64_t, uint16_t /* channelWidth */, uint16_t /* guardInterval */, uint8_t /* nss */> PhyRateCallback;
-  /**
-   * Typedef for callback used to calculate PHY rate of a WifiMode
-   * from a TXVECTOR. This is mostly useful in HE or later amendments.
-   * For the others it's a simple wrapper of \see PhyRateCallback.
+   * from a TXVECTOR.
    *
    * \param txVector the TXVECTOR used for the transmission
    * \param staId the station ID
    * \return the physical bit rate of the signal in bps.
    */
-  typedef Callback<uint64_t, const WifiTxVector& /* txVector */, uint16_t /* staId */> PhyRateFromTxVectorCallback;
+  typedef Callback<uint64_t, const WifiTxVector& /* txVector */, uint16_t /* staId */> PhyRateCallback;
   /**
    * Typedef for callback used to calculate data rate of a WifiMode
-   *
-   * \param channelWidth the channel width in MHz
-   * \param guardInterval the guard interval duration in nanoseconds
-   * \param nss the number of streams
-   * \return the data rate of the signal in bps.
-   */
-  typedef Callback<uint64_t, uint16_t /* channelWidth */, uint16_t /* guardInterval */, uint8_t /* nss */> DataRateCallback;
-  /**
-   * Typedef for callback used to calculate data rate of a WifiMode
-   * from a TXVECTOR. This is mostly useful in HE or later amendments.
-   * For the others it's a simple wrapper of \see DataRateCallback.
+   * from a TXVECTOR.
    *
    * \param txVector the TXVECTOR used for the transmission
    * \param staId the station ID
    * \return the data rate of the signal in bps.
    */
-  typedef Callback<uint64_t, const WifiTxVector& /* txVector */, uint16_t /* staId */> DataRateFromTxVectorCallback;
+  typedef Callback<uint64_t, const WifiTxVector& /* txVector */, uint16_t /* staId */> DataRateCallback;
   /**
    * Typedef for callback used to calculate Non-HT Reference Rate of
    * an MCS defined in HT or later amendment. For Non-HT modes (DSSS, OFDM,
@@ -324,14 +310,12 @@
    */
   typedef Callback<uint64_t> NonHtReferenceRateCallback;
   /**
-   * Typedef for callback used to check whether the combination of <current
-   * WifiMode, channel width (in MHz), number of stream> is allowed
+   * Typedef for callback used to check whether a given combination is allowed
    *
-   * \param channelWidth the channel width in MHz
-   * \param nss the number of streams
-   * \return true if combination of current WifiMode and supplied parameters is allowed.
+   * \param txVector the TXVECTOR containing the combination to check
+   * \return true if combination of current WifiMode and TXVECTOR is allowed.
    */
-  typedef Callback<bool, uint16_t /* channelWidth */, uint8_t /* nss */> ModeAllowedCallback;
+  typedef Callback<bool, const WifiTxVector& /* txVector */> AllowedCallback;
 
   /**
    * \param uniqueName the name of the associated WifiMode. This name
@@ -347,15 +331,10 @@
    *        order of the constellation used.
    * \param phyRateCallback a callback function to calculate the PHY rate (in
    *        bps) of this WifiMode.
-   * \param phyRateFromTxVectorCallback a callback function to calculate the PHY rate
-   *        (in bps) of this WifiMode using a TXVECTOR as input.
    * \param dataRateCallback a callback function to calculate the data rate
    *        (in bps) of this WifiMode.
-   * \param dataRateFromTxVectorCallback a callback function to calculate the data rate
-   *        (in bps) of this WifiMode using a TXVECTOR as input.
-   * \param isModeAllowedCallback a callback function to check whether a
-   *        specific combination of this WifiMode, channel width (MHz), and
-   *        NSS are allowed.
+   * \param isAllowedCallback a callback function to check whether a
+   *        specific combination of this WifiMode is allowed.
    *
    * \return WifiMode
    *
@@ -367,33 +346,27 @@
                                   CodeRateCallback codeRateCallback,
                                   ConstellationSizeCallback constellationSizeCallback,
                                   PhyRateCallback phyRateCallback,
-                                  PhyRateFromTxVectorCallback phyRateFromTxVectorCallback,
                                   DataRateCallback dataRateCallback,
-                                  DataRateFromTxVectorCallback dataRateFromTxVectorCallback,
-                                  ModeAllowedCallback isModeAllowedCallback);
+                                  AllowedCallback isAllowedCallback);
 
   /**
    * \param uniqueName the name of the associated WifiMode. This name
    *        must be unique across _all_ instances.
    * \param mcsValue the MCS value
    * \param modClass the class of modulation
+   * \param isMandatory true if this WifiMode is mandatory, false otherwise.
    * \param codeRateCallback a callback function that returns the coding rate
    *        of this WifiMode.
    * \param constellationSizeCallback a callback function that returns the size
    *        of modulation constellation of this WifiMode.
    * \param phyRateCallback a callback function to calculate the PHY rate (in
    *        bps) of this WifiMode.
-   * \param phyRateFromTxVectorCallback a callback function to calculate the PHY rate
-   *        (in bps) of this WifiMode using a TXVECTOR as input.
    * \param dataRateCallback a callback function to calculate the data rate (in
    *        bps) of this WifiMode.
-   * \param dataRateFromTxVectorCallback a callback function to calculate the data rate
-   *        (in bps) of this WifiMode using a TXVECTOR as input.
    * \param nonHtReferenceRateCallback a callback function to calculate the rate
    *        (in bps) of the non-HT Reference Rate of this WifiMode.
-   * \param isModeAllowedCallback a callback function to calculate whether a
-   *        combination of <MCS index, channel width (MHz), number of spatial
-   *        stream> is allowed for this WifiMode.
+   * \param isAllowedCallback a callback function to calculate whether a given
+   *        combination of is allowed for this WifiMode.
    *
    * \return WifiMode
    *
@@ -402,14 +375,13 @@
   static WifiMode CreateWifiMcs (std::string uniqueName,
                                  uint8_t mcsValue,
                                  WifiModulationClass modClass,
+                                 bool isMandatory,
                                  CodeRateCallback codeRateCallback,
                                  ConstellationSizeCallback constellationSizeCallback,
                                  PhyRateCallback phyRateCallback,
-                                 PhyRateFromTxVectorCallback phyRateFromTxVectorCallback,
                                  DataRateCallback dataRateCallback,
-                                 DataRateFromTxVectorCallback dataRateFromTxVectorCallback,
                                  NonHtReferenceRateCallback nonHtReferenceRateCallback,
-                                 ModeAllowedCallback isModeAllowedCallback);
+                                 AllowedCallback isAllowedCallback);
 
 
 private:
@@ -439,11 +411,9 @@
     CodeRateCallback GetCodeRateCallback;                         ///< Callback to retrieve code rate of this WifiModeItem
     ConstellationSizeCallback GetConstellationSizeCallback;       ///< Callback to retrieve constellation size of this WifiModeItem
     PhyRateCallback GetPhyRateCallback;                           ///< Callback to calculate PHY rate in bps of this WifiModeItem
-    PhyRateFromTxVectorCallback GetPhyRateFromTxVectorCallback;   ///< Callback to calculate PHY rate in bps of this WifiModeItem using a TXVECTOR as input
     DataRateCallback GetDataRateCallback;                         ///< Callback to calculate data rate in bps of this WifiModeItem
-    DataRateFromTxVectorCallback GetDataRateFromTxVectorCallback; ///< Callback to calculate data rate in bps of this WifiModeItem using a TXVECTOR as input
     NonHtReferenceRateCallback GetNonHtReferenceRateCallback;     ///< Callback to calculate non-HT reference rate of this WifiModeItem
-    ModeAllowedCallback IsModeAllowedCallback;                    ///< Callback to check whether the combination of <MCS, channel width (MHz), NSS> is allowed
+    AllowedCallback IsAllowedCallback;                            ///< Callback to check whether a given combination of is allowed
   };
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-net-device.cc ns-3.36/src/wifi/model/wifi-net-device.cc
--- ns-3.35/src/wifi/model/wifi-net-device.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-net-device.cc	2022-04-30 18:23:58.218735200 -0700
@@ -88,7 +88,8 @@
 }
 
 WifiNetDevice::WifiNetDevice ()
-  : m_configComplete (false)
+  : m_standard (WIFI_STANDARD_UNSPECIFIED),
+    m_configComplete (false)
 {
   NS_LOG_FUNCTION_NOARGS ();
 }
@@ -177,6 +178,19 @@
 }
 
 void
+WifiNetDevice::SetStandard (WifiStandard standard)
+{
+  NS_ABORT_MSG_IF (m_standard != WIFI_STANDARD_UNSPECIFIED, "Wifi standard already set");
+  m_standard = standard;
+}
+
+WifiStandard
+WifiNetDevice::GetStandard (void) const
+{
+  return m_standard;
+}
+
+void
 WifiNetDevice::SetMac (const Ptr<WifiMac> mac)
 {
   m_mac = mac;
@@ -455,7 +469,7 @@
 Ptr<HtConfiguration>
 WifiNetDevice::GetHtConfiguration (void) const
 {
-  return m_htConfiguration;
+  return (m_standard >= WIFI_STANDARD_80211n ? m_htConfiguration : nullptr);
 }
 
 void
@@ -467,7 +481,8 @@
 Ptr<VhtConfiguration>
 WifiNetDevice::GetVhtConfiguration (void) const
 {
-  return m_vhtConfiguration;
+  return (m_standard >= WIFI_STANDARD_80211ac && m_phy->GetPhyBand () == WIFI_PHY_BAND_5GHZ
+          ? m_vhtConfiguration : nullptr);
 }
 
 void
@@ -479,7 +494,7 @@
 Ptr<HeConfiguration>
 WifiNetDevice::GetHeConfiguration (void) const
 {
-  return m_heConfiguration;
+  return (m_standard >= WIFI_STANDARD_80211ax ? m_heConfiguration : nullptr);
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-net-device.h ns-3.36/src/wifi/model/wifi-net-device.h
--- ns-3.35/src/wifi/model/wifi-net-device.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-net-device.h	2022-04-30 18:23:58.218735200 -0700
@@ -23,6 +23,7 @@
 
 #include "ns3/net-device.h"
 #include "ns3/traced-callback.h"
+#include "wifi-standards.h"
 
 namespace ns3 {
 
@@ -62,6 +63,23 @@
   WifiNetDevice ();
   virtual ~WifiNetDevice ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  WifiNetDevice (const WifiNetDevice &o) = delete;
+  WifiNetDevice &operator = (const WifiNetDevice &) = delete;
+
+  /**
+   * Set the Wifi standard.
+   *
+   * \param standard the Wifi standard
+   */
+  void SetStandard (WifiStandard standard);
+  /**
+   * Get the Wifi standard.
+   *
+   * \return the Wifi standard
+   */
+  WifiStandard GetStandard (void) const;
+
   /**
    * \param mac the MAC layer to use.
    */
@@ -154,23 +172,6 @@
 
 private:
   /**
-   * \brief Copy constructor
-   * \param o object to copy
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  WifiNetDevice (const WifiNetDevice &o);
-
-  /**
-   * \brief Assignment operator
-   * \param o object to copy
-   * \returns the copied object
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  WifiNetDevice &operator = (const WifiNetDevice &o);
-
-  /**
    * Set that the link is up. A link is always up in ad-hoc mode.
    * For a STA, a link is up when the STA is associated with an AP.
    */
@@ -198,6 +199,7 @@
   TracedCallback<Ptr<const Packet>, Mac48Address> m_rxLogger; //!< receive trace callback
   TracedCallback<Ptr<const Packet>, Mac48Address> m_txLogger; //!< transmit trace callback
 
+  WifiStandard m_standard; //!< Wifi standard
   uint32_t m_ifIndex; //!< IF index
   bool m_linkUp; //!< link up
   TracedCallback<> m_linkChanges; //!< link change callback
